import { ModuleWithProviders } from '@angular/core';
import { ROUTE_META_CONFIG, RouterMetaConfig } from './router-meta';
import { RouterMetaService } from './router-meta.service';
import { TypedProvider, TypedProviderI } from './typed-provider';
export declare type ConfigProvider = TypedProvider<typeof ROUTE_META_CONFIG>;
export interface RouterMetaModuleConfig<C extends ConfigProvider> {
    config?: RouterMetaConfig;
    configProvider?: C & TypedProviderI<typeof ROUTE_META_CONFIG, C>;
}
export declare class RouterMetaModule {
    static forRoot<C extends ConfigProvider>(config?: RouterMetaModuleConfig<C>): ModuleWithProviders<RouterMetaModule>;
    constructor(parentModule: RouterMetaModule, routerMetaService: RouterMetaService);
}
